/* accelerator.c generated by valac 0.38.3, the Vala compiler
 * generated from accelerator.vala, do not modify */

/*
 * based on keyboard-shortcuts.c from gnome-control-center
 *
 * Copyright (c) 2013 gnome-pomodoro contributors
 *               2010 Intel, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Kamil Prusko <kamilprusko@gmail.com>
 *          Thomas Wood <thomas.wood@intel.com>
 *          Rodrigo Moya <rodrigo@gnome.org>
 */
/* TODO:
 * Handle integration with window manager
 *  - suppress any keybings from being triggered
 *  - if keybinding is taken, notify about it
 *
 * For now gnome-shell extension is responsible for setting it.
 */

#include <glib.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>


#define POMODORO_TYPE_ACCELERATOR (pomodoro_accelerator_get_type ())
#define POMODORO_ACCELERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POMODORO_TYPE_ACCELERATOR, PomodoroAccelerator))
#define POMODORO_ACCELERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POMODORO_TYPE_ACCELERATOR, PomodoroAcceleratorClass))
#define POMODORO_IS_ACCELERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POMODORO_TYPE_ACCELERATOR))
#define POMODORO_IS_ACCELERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POMODORO_TYPE_ACCELERATOR))
#define POMODORO_ACCELERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POMODORO_TYPE_ACCELERATOR, PomodoroAcceleratorClass))

typedef struct _PomodoroAccelerator PomodoroAccelerator;
typedef struct _PomodoroAcceleratorClass PomodoroAcceleratorClass;
typedef struct _PomodoroAcceleratorPrivate PomodoroAcceleratorPrivate;
enum  {
	POMODORO_ACCELERATOR_0_PROPERTY,
	POMODORO_ACCELERATOR_NAME_PROPERTY,
	POMODORO_ACCELERATOR_DISPLAY_NAME_PROPERTY,
	POMODORO_ACCELERATOR_NUM_PROPERTIES
};
static GParamSpec* pomodoro_accelerator_properties[POMODORO_ACCELERATOR_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
enum  {
	POMODORO_ACCELERATOR_CHANGED_SIGNAL,
	POMODORO_ACCELERATOR_NUM_SIGNALS
};
static guint pomodoro_accelerator_signals[POMODORO_ACCELERATOR_NUM_SIGNALS] = {0};

typedef enum  {
	POMODORO_ACCELERATOR_ERROR_INVALID,
	POMODORO_ACCELERATOR_ERROR_FORBIDDEN,
	POMODORO_ACCELERATOR_ERROR_TYPING_COLLISION
} PomodoroAcceleratorError;
#define POMODORO_ACCELERATOR_ERROR pomodoro_accelerator_error_quark ()
struct _PomodoroAccelerator {
	GObject parent_instance;
	PomodoroAcceleratorPrivate * priv;
};

struct _PomodoroAcceleratorClass {
	GObjectClass parent_class;
	void (*changed) (PomodoroAccelerator* self);
};

struct _PomodoroAcceleratorPrivate {
	guint _key;
	GdkModifierType _modifiers;
};


static gpointer pomodoro_accelerator_parent_class = NULL;

GQuark pomodoro_accelerator_error_quark (void);
GType pomodoro_accelerator_get_type (void) G_GNUC_CONST;
#define POMODORO_ACCELERATOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), POMODORO_TYPE_ACCELERATOR, PomodoroAcceleratorPrivate))
PomodoroAccelerator* pomodoro_accelerator_new_from_name (const gchar* name);
PomodoroAccelerator* pomodoro_accelerator_construct_from_name (GType object_type, const gchar* name);
void pomodoro_accelerator_set_name (PomodoroAccelerator* self, const gchar* value);
static void pomodoro_accelerator_parse (const gchar* name, guint* keyval, GdkModifierType* modifiers);
void pomodoro_accelerator_unset (PomodoroAccelerator* self);
static void pomodoro_accelerator_set_key (PomodoroAccelerator* self, guint value);
static void pomodoro_accelerator_set_modifiers (PomodoroAccelerator* self, GdkModifierType value);
static void pomodoro_accelerator_normalize (guint* keyval, GdkModifierType* modifiers);
void pomodoro_accelerator_set_keyval (PomodoroAccelerator* self, guint keyval, GdkModifierType modifiers);
static guint pomodoro_accelerator_get_key (PomodoroAccelerator* self);
static GdkModifierType pomodoro_accelerator_get_modifiers (PomodoroAccelerator* self);
void pomodoro_accelerator_validate (PomodoroAccelerator* self, GError** error);
static gchar** pomodoro_accelerator_get_keys_internal (PomodoroAccelerator* self, gboolean escape, int* result_length1);
static void _vala_array_add1 (gchar** * array, int* length, int* size, gchar* value);
static void _vala_array_add2 (gchar** * array, int* length, int* size, gchar* value);
static void _vala_array_add3 (gchar** * array, int* length, int* size, gchar* value);
static void _vala_array_add4 (gchar** * array, int* length, int* size, gchar* value);
static void _vala_array_add5 (gchar** * array, int* length, int* size, gchar* value);
static void _vala_array_add6 (gchar** * array, int* length, int* size, gchar* value);
gchar** pomodoro_accelerator_get_keys (PomodoroAccelerator* self, int* result_length1);
PomodoroAccelerator* pomodoro_accelerator_new (void);
PomodoroAccelerator* pomodoro_accelerator_construct (GType object_type);
gchar* pomodoro_accelerator_get_name (PomodoroAccelerator* self);
gchar* pomodoro_accelerator_get_display_name (PomodoroAccelerator* self);
static void pomodoro_accelerator_real_changed (PomodoroAccelerator* self);
static void pomodoro_accelerator_finalize (GObject * obj);
static void _vala_pomodoro_accelerator_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_pomodoro_accelerator_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


GQuark pomodoro_accelerator_error_quark (void) {
	return g_quark_from_static_string ("pomodoro_accelerator_error-quark");
}


PomodoroAccelerator* pomodoro_accelerator_construct_from_name (GType object_type, const gchar* name) {
	PomodoroAccelerator * self = NULL;
	const gchar* _tmp0_;
	g_return_val_if_fail (name != NULL, NULL);
	self = (PomodoroAccelerator*) g_object_new (object_type, NULL);
	_tmp0_ = name;
	pomodoro_accelerator_set_name (self, _tmp0_);
	return self;
}


PomodoroAccelerator* pomodoro_accelerator_new_from_name (const gchar* name) {
	return pomodoro_accelerator_construct_from_name (POMODORO_TYPE_ACCELERATOR, name);
}


static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	glong _tmp0_;
	gchar _tmp1_;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = index;
	_tmp1_ = ((gchar*) self)[_tmp0_];
	result = _tmp1_;
	return result;
}


static gchar* string_slice (const gchar* self, glong start, glong end) {
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	glong _tmp2_;
	glong _tmp5_;
	gboolean _tmp8_ = FALSE;
	glong _tmp9_;
	gboolean _tmp12_ = FALSE;
	glong _tmp13_;
	glong _tmp16_;
	glong _tmp17_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	gchar* _tmp21_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	_tmp2_ = start;
	if (_tmp2_ < ((glong) 0)) {
		glong _tmp3_;
		glong _tmp4_;
		_tmp3_ = string_length;
		_tmp4_ = start;
		start = _tmp3_ + _tmp4_;
	}
	_tmp5_ = end;
	if (_tmp5_ < ((glong) 0)) {
		glong _tmp6_;
		glong _tmp7_;
		_tmp6_ = string_length;
		_tmp7_ = end;
		end = _tmp6_ + _tmp7_;
	}
	_tmp9_ = start;
	if (_tmp9_ >= ((glong) 0)) {
		glong _tmp10_;
		glong _tmp11_;
		_tmp10_ = start;
		_tmp11_ = string_length;
		_tmp8_ = _tmp10_ <= _tmp11_;
	} else {
		_tmp8_ = FALSE;
	}
	g_return_val_if_fail (_tmp8_, NULL);
	_tmp13_ = end;
	if (_tmp13_ >= ((glong) 0)) {
		glong _tmp14_;
		glong _tmp15_;
		_tmp14_ = end;
		_tmp15_ = string_length;
		_tmp12_ = _tmp14_ <= _tmp15_;
	} else {
		_tmp12_ = FALSE;
	}
	g_return_val_if_fail (_tmp12_, NULL);
	_tmp16_ = start;
	_tmp17_ = end;
	g_return_val_if_fail (_tmp16_ <= _tmp17_, NULL);
	_tmp18_ = start;
	_tmp19_ = end;
	_tmp20_ = start;
	_tmp21_ = g_strndup (((gchar*) self) + _tmp18_, (gsize) (_tmp19_ - _tmp20_));
	result = _tmp21_;
	return result;
}


static void pomodoro_accelerator_parse (const gchar* name, guint* keyval, GdkModifierType* modifiers) {
	guint _vala_keyval = 0U;
	GdkModifierType _vala_modifiers = 0;
	gint pos = 0;
	gint start = 0;
	gchar chr = '\0';
	gboolean is_modifier = FALSE;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	const gchar* _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	guint _tmp33_;
	pos = 0;
	start = 0;
	chr = '\0';
	is_modifier = FALSE;
	_vala_keyval = (guint) 0;
	_vala_modifiers = 0;
	_tmp1_ = name;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp2_;
		_tmp2_ = name;
		_tmp0_ = g_strcmp0 (_tmp2_, "") == 0;
	}
	if (_tmp0_) {
		if (keyval) {
			*keyval = _vala_keyval;
		}
		if (modifiers) {
			*modifiers = _vala_modifiers;
		}
		return;
	}
	while (TRUE) {
		const gchar* _tmp3_;
		gint _tmp4_;
		gchar _tmp5_;
		gchar _tmp6_;
		gchar _tmp7_;
		gint _tmp27_;
		_tmp3_ = name;
		_tmp4_ = pos;
		_tmp5_ = string_get (_tmp3_, (glong) _tmp4_);
		chr = _tmp5_;
		_tmp6_ = chr;
		if (!(_tmp6_ != '\0')) {
			break;
		}
		_tmp7_ = chr;
		if (_tmp7_ == '<') {
			gint _tmp8_;
			_tmp8_ = pos;
			start = _tmp8_ + 1;
			is_modifier = TRUE;
		} else {
			gboolean _tmp9_ = FALSE;
			gchar _tmp10_;
			_tmp10_ = chr;
			if (_tmp10_ == '>') {
				gboolean _tmp11_;
				_tmp11_ = is_modifier;
				_tmp9_ = _tmp11_;
			} else {
				_tmp9_ = FALSE;
			}
			if (_tmp9_) {
				gchar* modifier = NULL;
				const gchar* _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
				gchar* _tmp15_;
				gboolean _tmp16_ = FALSE;
				const gchar* _tmp17_;
				const gchar* _tmp20_;
				const gchar* _tmp22_;
				const gchar* _tmp24_;
				gint _tmp26_;
				_tmp12_ = name;
				_tmp13_ = start;
				_tmp14_ = pos;
				_tmp15_ = string_slice (_tmp12_, (glong) _tmp13_, (glong) _tmp14_);
				modifier = _tmp15_;
				_tmp17_ = modifier;
				if (g_strcmp0 (_tmp17_, "Ctrl") == 0) {
					_tmp16_ = TRUE;
				} else {
					const gchar* _tmp18_;
					_tmp18_ = modifier;
					_tmp16_ = g_strcmp0 (_tmp18_, "Control") == 0;
				}
				if (_tmp16_) {
					GdkModifierType _tmp19_;
					_tmp19_ = _vala_modifiers;
					_vala_modifiers = _tmp19_ | GDK_CONTROL_MASK;
				}
				_tmp20_ = modifier;
				if (g_strcmp0 (_tmp20_, "Alt") == 0) {
					GdkModifierType _tmp21_;
					_tmp21_ = _vala_modifiers;
					_vala_modifiers = _tmp21_ | GDK_MOD1_MASK;
				}
				_tmp22_ = modifier;
				if (g_strcmp0 (_tmp22_, "Shift") == 0) {
					GdkModifierType _tmp23_;
					_tmp23_ = _vala_modifiers;
					_vala_modifiers = _tmp23_ | GDK_SHIFT_MASK;
				}
				_tmp24_ = modifier;
				if (g_strcmp0 (_tmp24_, "Super") == 0) {
					GdkModifierType _tmp25_;
					_tmp25_ = _vala_modifiers;
					_vala_modifiers = _tmp25_ | GDK_SUPER_MASK;
				}
				is_modifier = FALSE;
				_tmp26_ = pos;
				start = _tmp26_ + 1;
				_g_free0 (modifier);
			}
		}
		_tmp27_ = pos;
		pos = _tmp27_ + 1;
	}
	_tmp28_ = name;
	_tmp29_ = start;
	_tmp30_ = pos;
	_tmp31_ = string_slice (_tmp28_, (glong) _tmp29_, (glong) _tmp30_);
	_tmp32_ = _tmp31_;
	_tmp33_ = gdk_keyval_from_name (_tmp32_);
	_vala_keyval = _tmp33_;
	_g_free0 (_tmp32_);
	if (keyval) {
		*keyval = _vala_keyval;
	}
	if (modifiers) {
		*modifiers = _vala_modifiers;
	}
}


void pomodoro_accelerator_unset (PomodoroAccelerator* self) {
	g_return_if_fail (self != NULL);
	pomodoro_accelerator_set_key (self, (guint) 0);
	pomodoro_accelerator_set_modifiers (self, 0);
	g_signal_emit (self, pomodoro_accelerator_signals[POMODORO_ACCELERATOR_CHANGED_SIGNAL], 0);
}


static void pomodoro_accelerator_normalize (guint* keyval, GdkModifierType* modifiers) {
	GdkModifierType keyval_modifier = 0;
	guint _tmp0_;
	GdkModifierType _tmp1_;
	GdkModifierType _tmp4_;
	keyval_modifier = 0;
	_tmp0_ = *keyval;
	switch (_tmp0_) {
		case GDK_KEY_Control_L:
		case GDK_KEY_Control_R:
		{
			keyval_modifier = GDK_CONTROL_MASK;
			break;
		}
		case GDK_KEY_Shift_L:
		case GDK_KEY_Shift_R:
		{
			keyval_modifier = GDK_SHIFT_MASK;
			break;
		}
		case GDK_KEY_Super_L:
		case GDK_KEY_Super_R:
		{
			keyval_modifier = GDK_SUPER_MASK;
			break;
		}
		case GDK_KEY_Alt_L:
		case GDK_KEY_Alt_R:
		{
			keyval_modifier = GDK_MOD1_MASK;
			break;
		}
		default:
		break;
	}
	_tmp1_ = keyval_modifier;
	if (_tmp1_ != 0) {
		GdkModifierType _tmp2_;
		GdkModifierType _tmp3_;
		*keyval = (guint) 0;
		_tmp2_ = *modifiers;
		_tmp3_ = keyval_modifier;
		*modifiers = _tmp2_ | _tmp3_;
	}
	_tmp4_ = *modifiers;
	*modifiers = _tmp4_ & (((GDK_CONTROL_MASK | GDK_SHIFT_MASK) | GDK_SUPER_MASK) | GDK_MOD1_MASK);
}


void pomodoro_accelerator_set_keyval (PomodoroAccelerator* self, guint keyval, GdkModifierType modifiers) {
	gboolean _tmp0_ = FALSE;
	guint _tmp1_;
	guint _tmp2_;
	g_return_if_fail (self != NULL);
	pomodoro_accelerator_normalize (&keyval, &modifiers);
	_tmp1_ = self->priv->_key;
	_tmp2_ = keyval;
	if (_tmp1_ != _tmp2_) {
		_tmp0_ = TRUE;
	} else {
		GdkModifierType _tmp3_;
		GdkModifierType _tmp4_;
		_tmp3_ = self->priv->_modifiers;
		_tmp4_ = modifiers;
		_tmp0_ = _tmp3_ != _tmp4_;
	}
	if (_tmp0_) {
		guint _tmp5_;
		GdkModifierType _tmp6_;
		_tmp5_ = keyval;
		pomodoro_accelerator_set_key (self, _tmp5_);
		_tmp6_ = modifiers;
		pomodoro_accelerator_set_modifiers (self, _tmp6_);
		g_signal_emit (self, pomodoro_accelerator_signals[POMODORO_ACCELERATOR_CHANGED_SIGNAL], 0);
	}
}


void pomodoro_accelerator_validate (PomodoroAccelerator* self, GError** error) {
	guint key = 0U;
	guint _tmp0_;
	GdkModifierType modifiers = 0;
	GdkModifierType _tmp1_;
	gboolean _tmp2_ = FALSE;
	guint _tmp3_;
	guint _tmp5_;
	GdkModifierType _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp9_ = FALSE;
	guint _tmp10_;
	gboolean _tmp18_ = FALSE;
	guint _tmp19_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_key;
	key = _tmp0_;
	_tmp1_ = self->priv->_modifiers;
	modifiers = _tmp1_;
	_tmp3_ = key;
	if (_tmp3_ == ((guint) 0)) {
		GdkModifierType _tmp4_;
		_tmp4_ = modifiers;
		_tmp2_ = _tmp4_ == 0;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		return;
	}
	_tmp5_ = key;
	_tmp6_ = modifiers;
	_tmp7_ = gtk_accelerator_valid (_tmp5_, _tmp6_);
	if (!_tmp7_) {
		GError* _tmp8_;
		_tmp8_ = g_error_new_literal (POMODORO_ACCELERATOR_ERROR, POMODORO_ACCELERATOR_ERROR_INVALID, "Invalid");
		_inner_error_ = _tmp8_;
		if (_inner_error_->domain == POMODORO_ACCELERATOR_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp10_ = key;
	if (_tmp10_ != ((guint) 0)) {
		GdkModifierType _tmp11_;
		_tmp11_ = modifiers;
		_tmp9_ = _tmp11_ == 0;
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		gboolean _tmp12_ = FALSE;
		gboolean _tmp13_ = FALSE;
		guint _tmp14_;
		_tmp14_ = key;
		if (_tmp14_ == ((guint) GDK_KEY_Escape)) {
			_tmp13_ = TRUE;
		} else {
			guint _tmp15_;
			_tmp15_ = key;
			_tmp13_ = _tmp15_ == ((guint) GDK_KEY_BackSpace);
		}
		if (_tmp13_) {
			_tmp12_ = TRUE;
		} else {
			guint _tmp16_;
			_tmp16_ = key;
			_tmp12_ = _tmp16_ == ((guint) GDK_KEY_Return);
		}
		if (_tmp12_) {
			GError* _tmp17_;
			_tmp17_ = g_error_new_literal (POMODORO_ACCELERATOR_ERROR, POMODORO_ACCELERATOR_ERROR_FORBIDDEN, "Forbidden");
			_inner_error_ = _tmp17_;
			if (_inner_error_->domain == POMODORO_ACCELERATOR_ERROR) {
				g_propagate_error (error, _inner_error_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	_tmp19_ = key;
	if (_tmp19_ != ((guint) 0)) {
		gboolean _tmp20_ = FALSE;
		GdkModifierType _tmp21_;
		_tmp21_ = modifiers;
		if (_tmp21_ == 0) {
			_tmp20_ = TRUE;
		} else {
			GdkModifierType _tmp22_;
			_tmp22_ = modifiers;
			_tmp20_ = _tmp22_ == GDK_SHIFT_MASK;
		}
		_tmp18_ = _tmp20_;
	} else {
		_tmp18_ = FALSE;
	}
	if (_tmp18_) {
		gboolean _tmp23_ = FALSE;
		gboolean _tmp24_ = FALSE;
		gboolean _tmp25_ = FALSE;
		gboolean _tmp26_ = FALSE;
		gboolean _tmp27_ = FALSE;
		gboolean _tmp28_ = FALSE;
		gboolean _tmp29_ = FALSE;
		gboolean _tmp30_ = FALSE;
		gboolean _tmp31_ = FALSE;
		gboolean _tmp32_ = FALSE;
		gboolean _tmp33_ = FALSE;
		guint _tmp34_;
		_tmp34_ = key;
		if (_tmp34_ >= ((guint) GDK_KEY_a)) {
			guint _tmp35_;
			_tmp35_ = key;
			_tmp33_ = _tmp35_ <= ((guint) GDK_KEY_z);
		} else {
			_tmp33_ = FALSE;
		}
		if (_tmp33_) {
			_tmp32_ = TRUE;
		} else {
			gboolean _tmp36_ = FALSE;
			guint _tmp37_;
			_tmp37_ = key;
			if (_tmp37_ >= ((guint) GDK_KEY_A)) {
				guint _tmp38_;
				_tmp38_ = key;
				_tmp36_ = _tmp38_ <= ((guint) GDK_KEY_Z);
			} else {
				_tmp36_ = FALSE;
			}
			_tmp32_ = _tmp36_;
		}
		if (_tmp32_) {
			_tmp31_ = TRUE;
		} else {
			gboolean _tmp39_ = FALSE;
			guint _tmp40_;
			_tmp40_ = key;
			if (_tmp40_ >= ((guint) GDK_KEY_0)) {
				guint _tmp41_;
				_tmp41_ = key;
				_tmp39_ = _tmp41_ <= ((guint) GDK_KEY_9);
			} else {
				_tmp39_ = FALSE;
			}
			_tmp31_ = _tmp39_;
		}
		if (_tmp31_) {
			_tmp30_ = TRUE;
		} else {
			gboolean _tmp42_ = FALSE;
			guint _tmp43_;
			_tmp43_ = key;
			if (_tmp43_ >= ((guint) GDK_KEY_kana_fullstop)) {
				guint _tmp44_;
				_tmp44_ = key;
				_tmp42_ = _tmp44_ <= ((guint) GDK_KEY_semivoicedsound);
			} else {
				_tmp42_ = FALSE;
			}
			_tmp30_ = _tmp42_;
		}
		if (_tmp30_) {
			_tmp29_ = TRUE;
		} else {
			gboolean _tmp45_ = FALSE;
			guint _tmp46_;
			_tmp46_ = key;
			if (_tmp46_ >= ((guint) GDK_KEY_Arabic_comma)) {
				guint _tmp47_;
				_tmp47_ = key;
				_tmp45_ = _tmp47_ <= ((guint) GDK_KEY_Arabic_sukun);
			} else {
				_tmp45_ = FALSE;
			}
			_tmp29_ = _tmp45_;
		}
		if (_tmp29_) {
			_tmp28_ = TRUE;
		} else {
			gboolean _tmp48_ = FALSE;
			guint _tmp49_;
			_tmp49_ = key;
			if (_tmp49_ >= ((guint) GDK_KEY_Serbian_dje)) {
				guint _tmp50_;
				_tmp50_ = key;
				_tmp48_ = _tmp50_ <= ((guint) GDK_KEY_Cyrillic_HARDSIGN);
			} else {
				_tmp48_ = FALSE;
			}
			_tmp28_ = _tmp48_;
		}
		if (_tmp28_) {
			_tmp27_ = TRUE;
		} else {
			gboolean _tmp51_ = FALSE;
			guint _tmp52_;
			_tmp52_ = key;
			if (_tmp52_ >= ((guint) GDK_KEY_Greek_ALPHAaccent)) {
				guint _tmp53_;
				_tmp53_ = key;
				_tmp51_ = _tmp53_ <= ((guint) GDK_KEY_Greek_omega);
			} else {
				_tmp51_ = FALSE;
			}
			_tmp27_ = _tmp51_;
		}
		if (_tmp27_) {
			_tmp26_ = TRUE;
		} else {
			gboolean _tmp54_ = FALSE;
			guint _tmp55_;
			_tmp55_ = key;
			if (_tmp55_ >= ((guint) GDK_KEY_hebrew_doublelowline)) {
				guint _tmp56_;
				_tmp56_ = key;
				_tmp54_ = _tmp56_ <= ((guint) GDK_KEY_hebrew_taf);
			} else {
				_tmp54_ = FALSE;
			}
			_tmp26_ = _tmp54_;
		}
		if (_tmp26_) {
			_tmp25_ = TRUE;
		} else {
			gboolean _tmp57_ = FALSE;
			guint _tmp58_;
			_tmp58_ = key;
			if (_tmp58_ >= ((guint) GDK_KEY_Thai_kokai)) {
				guint _tmp59_;
				_tmp59_ = key;
				_tmp57_ = _tmp59_ <= ((guint) GDK_KEY_Thai_lekkao);
			} else {
				_tmp57_ = FALSE;
			}
			_tmp25_ = _tmp57_;
		}
		if (_tmp25_) {
			_tmp24_ = TRUE;
		} else {
			gboolean _tmp60_ = FALSE;
			guint _tmp61_;
			_tmp61_ = key;
			if (_tmp61_ >= ((guint) GDK_KEY_Hangul)) {
				guint _tmp62_;
				_tmp62_ = key;
				_tmp60_ = _tmp62_ <= ((guint) GDK_KEY_Hangul_Special);
			} else {
				_tmp60_ = FALSE;
			}
			_tmp24_ = _tmp60_;
		}
		if (_tmp24_) {
			_tmp23_ = TRUE;
		} else {
			gboolean _tmp63_ = FALSE;
			guint _tmp64_;
			_tmp64_ = key;
			if (_tmp64_ >= ((guint) GDK_KEY_Hangul_Kiyeog)) {
				guint _tmp65_;
				_tmp65_ = key;
				_tmp63_ = _tmp65_ <= ((guint) GDK_KEY_Hangul_J_YeorinHieuh);
			} else {
				_tmp63_ = FALSE;
			}
			_tmp23_ = _tmp63_;
		}
		if (_tmp23_) {
			GError* _tmp66_;
			_tmp66_ = g_error_new_literal (POMODORO_ACCELERATOR_ERROR, POMODORO_ACCELERATOR_ERROR_TYPING_COLLISION, "Typing collision");
			_inner_error_ = _tmp66_;
			if (_inner_error_->domain == POMODORO_ACCELERATOR_ERROR) {
				g_propagate_error (error, _inner_error_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
}


static void _vala_array_add1 (gchar** * array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add2 (gchar** * array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add3 (gchar** * array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add4 (gchar** * array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add5 (gchar** * array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static gchar* g_unichar_to_string (gunichar self) {
	gchar* result = NULL;
	gchar* str = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	_tmp0_ = g_new0 (gchar, 7);
	str = (gchar*) _tmp0_;
	_tmp1_ = str;
	g_unichar_to_utf8 (self, _tmp1_);
	result = str;
	return result;
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		const gchar* _tmp2_;
		_tmp2_ = old;
		_tmp1_ = (*((gchar*) _tmp2_)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		_tmp3_ = old;
		_tmp4_ = replacement;
		_tmp0_ = g_strcmp0 (_tmp3_, _tmp4_) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp5_;
		_tmp5_ = g_strdup (self);
		result = _tmp5_;
		return result;
	}
	{
		GRegex* regex = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GRegex* _tmp9_;
		GRegex* _tmp10_;
		gchar* _tmp11_ = NULL;
		GRegex* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		_tmp6_ = old;
		_tmp7_ = g_regex_escape_string (_tmp6_, -1);
		_tmp8_ = _tmp7_;
		_tmp9_ = g_regex_new (_tmp8_, 0, 0, &_inner_error_);
		_tmp10_ = _tmp9_;
		_g_free0 (_tmp8_);
		regex = _tmp10_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp12_ = regex;
		_tmp13_ = replacement;
		_tmp14_ = g_regex_replace_literal (_tmp12_, self, (gssize) -1, 0, _tmp13_, 0, &_inner_error_);
		_tmp11_ = _tmp14_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp15_ = _tmp11_;
		_tmp11_ = NULL;
		result = _tmp15_;
		_g_free0 (_tmp11_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static void _vala_array_add6 (gchar** * array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static gchar** pomodoro_accelerator_get_keys_internal (PomodoroAccelerator* self, gboolean escape, int* result_length1) {
	gchar** result = NULL;
	gchar** elements = NULL;
	gchar** _tmp0_;
	gint elements_length1;
	gint _elements_size_;
	GdkModifierType _tmp1_;
	GdkModifierType _tmp6_;
	GdkModifierType _tmp11_;
	GdkModifierType _tmp16_;
	guint _tmp21_;
	gchar** _tmp41_;
	gint _tmp41__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_new0 (gchar*, 0 + 1);
	elements = _tmp0_;
	elements_length1 = 0;
	_elements_size_ = elements_length1;
	_tmp1_ = self->priv->_modifiers;
	if ((_tmp1_ & GDK_SHIFT_MASK) == GDK_SHIFT_MASK) {
		const gchar* _tmp2_ = NULL;
		gboolean _tmp3_;
		gchar** _tmp4_;
		gint _tmp4__length1;
		gchar* _tmp5_;
		_tmp3_ = escape;
		if (_tmp3_) {
			_tmp2_ = "<Shift>";
		} else {
			_tmp2_ = "Shift";
		}
		_tmp4_ = elements;
		_tmp4__length1 = elements_length1;
		_tmp5_ = g_strdup (_tmp2_);
		_vala_array_add1 (&elements, &elements_length1, &_elements_size_, _tmp5_);
	}
	_tmp6_ = self->priv->_modifiers;
	if ((_tmp6_ & GDK_SUPER_MASK) == GDK_SUPER_MASK) {
		const gchar* _tmp7_ = NULL;
		gboolean _tmp8_;
		gchar** _tmp9_;
		gint _tmp9__length1;
		gchar* _tmp10_;
		_tmp8_ = escape;
		if (_tmp8_) {
			_tmp7_ = "<Super>";
		} else {
			_tmp7_ = "Super";
		}
		_tmp9_ = elements;
		_tmp9__length1 = elements_length1;
		_tmp10_ = g_strdup (_tmp7_);
		_vala_array_add2 (&elements, &elements_length1, &_elements_size_, _tmp10_);
	}
	_tmp11_ = self->priv->_modifiers;
	if ((_tmp11_ & GDK_CONTROL_MASK) == GDK_CONTROL_MASK) {
		const gchar* _tmp12_ = NULL;
		gboolean _tmp13_;
		gchar** _tmp14_;
		gint _tmp14__length1;
		gchar* _tmp15_;
		_tmp13_ = escape;
		if (_tmp13_) {
			_tmp12_ = "<Ctrl>";
		} else {
			_tmp12_ = "Ctrl";
		}
		_tmp14_ = elements;
		_tmp14__length1 = elements_length1;
		_tmp15_ = g_strdup (_tmp12_);
		_vala_array_add3 (&elements, &elements_length1, &_elements_size_, _tmp15_);
	}
	_tmp16_ = self->priv->_modifiers;
	if ((_tmp16_ & GDK_MOD1_MASK) == GDK_MOD1_MASK) {
		const gchar* _tmp17_ = NULL;
		gboolean _tmp18_;
		gchar** _tmp19_;
		gint _tmp19__length1;
		gchar* _tmp20_;
		_tmp18_ = escape;
		if (_tmp18_) {
			_tmp17_ = "<Alt>";
		} else {
			_tmp17_ = "Alt";
		}
		_tmp19_ = elements;
		_tmp19__length1 = elements_length1;
		_tmp20_ = g_strdup (_tmp17_);
		_vala_array_add4 (&elements, &elements_length1, &_elements_size_, _tmp20_);
	}
	_tmp21_ = self->priv->_key;
	if (_tmp21_ != ((guint) 0)) {
		guint keyval = 0U;
		guint _tmp22_;
		guint _tmp23_;
		gchar* name = NULL;
		guint _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		gboolean _tmp27_;
		_tmp22_ = self->priv->_key;
		_tmp23_ = gdk_keyval_to_upper (_tmp22_);
		keyval = _tmp23_;
		_tmp24_ = keyval;
		_tmp25_ = gdk_keyval_name (_tmp24_);
		_tmp26_ = g_strdup (_tmp25_);
		name = _tmp26_;
		_tmp27_ = escape;
		if (_tmp27_) {
			gchar** _tmp28_;
			gint _tmp28__length1;
			const gchar* _tmp29_;
			gchar* _tmp30_;
			_tmp28_ = elements;
			_tmp28__length1 = elements_length1;
			_tmp29_ = name;
			_tmp30_ = g_strdup (_tmp29_);
			_vala_array_add5 (&elements, &elements_length1, &_elements_size_, _tmp30_);
		} else {
			gunichar key = 0U;
			guint _tmp31_;
			guint32 _tmp32_;
			gchar* _tmp33_ = NULL;
			gunichar _tmp34_;
			gchar** _tmp39_;
			gint _tmp39__length1;
			gchar* _tmp40_;
			_tmp31_ = keyval;
			_tmp32_ = gdk_keyval_to_unicode (_tmp31_);
			key = (gunichar) _tmp32_;
			_tmp34_ = key;
			if (_tmp34_ > ((gunichar) 0)) {
				gunichar _tmp35_;
				gchar* _tmp36_;
				_tmp35_ = key;
				_tmp36_ = g_unichar_to_string (_tmp35_);
				_g_free0 (_tmp33_);
				_tmp33_ = _tmp36_;
			} else {
				const gchar* _tmp37_;
				gchar* _tmp38_;
				_tmp37_ = name;
				_tmp38_ = string_replace (_tmp37_, "_", " ");
				_g_free0 (_tmp33_);
				_tmp33_ = _tmp38_;
			}
			_tmp39_ = elements;
			_tmp39__length1 = elements_length1;
			_tmp40_ = g_strdup (_tmp33_);
			_vala_array_add6 (&elements, &elements_length1, &_elements_size_, _tmp40_);
			_g_free0 (_tmp33_);
		}
		_g_free0 (name);
	}
	_tmp41_ = elements;
	_tmp41__length1 = elements_length1;
	if (result_length1) {
		*result_length1 = _tmp41__length1;
	}
	result = _tmp41_;
	return result;
}


gchar** pomodoro_accelerator_get_keys (PomodoroAccelerator* self, int* result_length1) {
	gchar** result = NULL;
	gint _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = pomodoro_accelerator_get_keys_internal (self, FALSE, &_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp2__length1 = _tmp0_;
	if (result_length1) {
		*result_length1 = _tmp2__length1;
	}
	result = _tmp2_;
	return result;
}


PomodoroAccelerator* pomodoro_accelerator_construct (GType object_type) {
	PomodoroAccelerator * self = NULL;
	self = (PomodoroAccelerator*) g_object_new (object_type, NULL);
	return self;
}


PomodoroAccelerator* pomodoro_accelerator_new (void) {
	return pomodoro_accelerator_construct (POMODORO_TYPE_ACCELERATOR);
}


static guint pomodoro_accelerator_get_key (PomodoroAccelerator* self) {
	guint result;
	guint _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_key;
	result = _tmp0_;
	return result;
}


static void pomodoro_accelerator_set_key (PomodoroAccelerator* self, guint value) {
	guint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_key = _tmp0_;
}


static GdkModifierType pomodoro_accelerator_get_modifiers (PomodoroAccelerator* self) {
	GdkModifierType result;
	GdkModifierType _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_modifiers;
	result = _tmp0_;
	return result;
}


static void pomodoro_accelerator_set_modifiers (PomodoroAccelerator* self, GdkModifierType value) {
	GdkModifierType _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_modifiers = _tmp0_;
}


gchar* pomodoro_accelerator_get_name (PomodoroAccelerator* self) {
	gchar* result;
	GString* name = NULL;
	GString* _tmp0_;
	gint _tmp1_;
	gchar** _tmp2_;
	GString* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_string_new ("");
	name = _tmp0_;
	_tmp2_ = pomodoro_accelerator_get_keys_internal (self, TRUE, &_tmp1_);
	{
		gchar** element_collection = NULL;
		gint element_collection_length1 = 0;
		gint _element_collection_size_ = 0;
		gint element_it = 0;
		element_collection = _tmp2_;
		element_collection_length1 = _tmp1_;
		for (element_it = 0; element_it < _tmp1_; element_it = element_it + 1) {
			gchar* _tmp3_;
			gchar* element = NULL;
			_tmp3_ = g_strdup (element_collection[element_it]);
			element = _tmp3_;
			{
				GString* _tmp4_;
				const gchar* _tmp5_;
				_tmp4_ = name;
				_tmp5_ = element;
				g_string_append (_tmp4_, _tmp5_);
				_g_free0 (element);
			}
		}
		element_collection = (_vala_array_free (element_collection, element_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	_tmp6_ = name;
	_tmp7_ = _tmp6_->str;
	_tmp8_ = g_strdup (_tmp7_);
	result = _tmp8_;
	_g_string_free0 (name);
	return result;
}


void pomodoro_accelerator_set_name (PomodoroAccelerator* self, const gchar* value) {
	guint keyval = 0U;
	GdkModifierType modifiers = 0;
	const gchar* _tmp0_;
	guint _tmp1_ = 0U;
	GdkModifierType _tmp2_ = 0;
	guint _tmp3_;
	GdkModifierType _tmp4_;
	g_return_if_fail (self != NULL);
	keyval = (guint) 0;
	modifiers = 0;
	_tmp0_ = value;
	pomodoro_accelerator_parse (_tmp0_, &_tmp1_, &_tmp2_);
	keyval = _tmp1_;
	modifiers = _tmp2_;
	_tmp3_ = keyval;
	_tmp4_ = modifiers;
	pomodoro_accelerator_set_keyval (self, _tmp3_, _tmp4_);
	g_object_notify_by_pspec ((GObject *) self, pomodoro_accelerator_properties[POMODORO_ACCELERATOR_NAME_PROPERTY]);
}


gchar* pomodoro_accelerator_get_display_name (PomodoroAccelerator* self) {
	gchar* result;
	GString* name = NULL;
	GString* _tmp0_;
	gboolean is_first = FALSE;
	gint _tmp1_;
	gchar** _tmp2_;
	GString* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_string_new ("");
	name = _tmp0_;
	is_first = TRUE;
	_tmp2_ = pomodoro_accelerator_get_keys_internal (self, FALSE, &_tmp1_);
	{
		gchar** element_collection = NULL;
		gint element_collection_length1 = 0;
		gint _element_collection_size_ = 0;
		gint element_it = 0;
		element_collection = _tmp2_;
		element_collection_length1 = _tmp1_;
		for (element_it = 0; element_it < _tmp1_; element_it = element_it + 1) {
			gchar* _tmp3_;
			gchar* element = NULL;
			_tmp3_ = g_strdup (element_collection[element_it]);
			element = _tmp3_;
			{
				gboolean _tmp4_;
				GString* _tmp6_;
				const gchar* _tmp7_;
				_tmp4_ = is_first;
				if (_tmp4_) {
					is_first = FALSE;
				} else {
					GString* _tmp5_;
					_tmp5_ = name;
					g_string_append (_tmp5_, " + ");
				}
				_tmp6_ = name;
				_tmp7_ = element;
				g_string_append (_tmp6_, _tmp7_);
				_g_free0 (element);
			}
		}
		element_collection = (_vala_array_free (element_collection, element_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	_tmp8_ = name;
	_tmp9_ = _tmp8_->str;
	_tmp10_ = g_strdup (_tmp9_);
	result = _tmp10_;
	_g_string_free0 (name);
	return result;
}


static void pomodoro_accelerator_real_changed (PomodoroAccelerator* self) {
	g_object_notify ((GObject*) self, "name");
	g_object_notify ((GObject*) self, "display-name");
}


static void pomodoro_accelerator_class_init (PomodoroAcceleratorClass * klass) {
	pomodoro_accelerator_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PomodoroAcceleratorPrivate));
	((PomodoroAcceleratorClass *) klass)->changed = pomodoro_accelerator_real_changed;
	G_OBJECT_CLASS (klass)->get_property = _vala_pomodoro_accelerator_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_pomodoro_accelerator_set_property;
	G_OBJECT_CLASS (klass)->finalize = pomodoro_accelerator_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_ACCELERATOR_NAME_PROPERTY, pomodoro_accelerator_properties[POMODORO_ACCELERATOR_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_ACCELERATOR_DISPLAY_NAME_PROPERTY, pomodoro_accelerator_properties[POMODORO_ACCELERATOR_DISPLAY_NAME_PROPERTY] = g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	pomodoro_accelerator_signals[POMODORO_ACCELERATOR_CHANGED_SIGNAL] = g_signal_new ("changed", POMODORO_TYPE_ACCELERATOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PomodoroAcceleratorClass, changed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void pomodoro_accelerator_instance_init (PomodoroAccelerator * self) {
	self->priv = POMODORO_ACCELERATOR_GET_PRIVATE (self);
}


static void pomodoro_accelerator_finalize (GObject * obj) {
	PomodoroAccelerator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_ACCELERATOR, PomodoroAccelerator);
	G_OBJECT_CLASS (pomodoro_accelerator_parent_class)->finalize (obj);
}


GType pomodoro_accelerator_get_type (void) {
	static volatile gsize pomodoro_accelerator_type_id__volatile = 0;
	if (g_once_init_enter (&pomodoro_accelerator_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PomodoroAcceleratorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_accelerator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroAccelerator), 0, (GInstanceInitFunc) pomodoro_accelerator_instance_init, NULL };
		GType pomodoro_accelerator_type_id;
		pomodoro_accelerator_type_id = g_type_register_static (G_TYPE_OBJECT, "PomodoroAccelerator", &g_define_type_info, 0);
		g_once_init_leave (&pomodoro_accelerator_type_id__volatile, pomodoro_accelerator_type_id);
	}
	return pomodoro_accelerator_type_id__volatile;
}


static void _vala_pomodoro_accelerator_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	PomodoroAccelerator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_ACCELERATOR, PomodoroAccelerator);
	switch (property_id) {
		case POMODORO_ACCELERATOR_NAME_PROPERTY:
		g_value_take_string (value, pomodoro_accelerator_get_name (self));
		break;
		case POMODORO_ACCELERATOR_DISPLAY_NAME_PROPERTY:
		g_value_take_string (value, pomodoro_accelerator_get_display_name (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_pomodoro_accelerator_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	PomodoroAccelerator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_ACCELERATOR, PomodoroAccelerator);
	switch (property_id) {
		case POMODORO_ACCELERATOR_NAME_PROPERTY:
		pomodoro_accelerator_set_name (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



