/* action.c generated by valac 0.38.3, the Vala compiler
 * generated from action.vala, do not modify */

/*
 * Copyright (c) 2016 gnome-pomodoro contributors
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <stdio.h>


#define ACTIONS_TYPE_ACTION (actions_action_get_type ())
#define ACTIONS_ACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ACTIONS_TYPE_ACTION, ActionsAction))
#define ACTIONS_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ACTIONS_TYPE_ACTION, ActionsActionClass))
#define ACTIONS_IS_ACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ACTIONS_TYPE_ACTION))
#define ACTIONS_IS_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ACTIONS_TYPE_ACTION))
#define ACTIONS_ACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ACTIONS_TYPE_ACTION, ActionsActionClass))

typedef struct _ActionsAction ActionsAction;
typedef struct _ActionsActionClass ActionsActionClass;
typedef struct _ActionsActionPrivate ActionsActionPrivate;

#define ACTIONS_TYPE_STATE (actions_state_get_type ())

#define ACTIONS_TYPE_TRIGGER (actions_trigger_get_type ())
enum  {
	ACTIONS_ACTION_0_PROPERTY,
	ACTIONS_ACTION_NAME_PROPERTY,
	ACTIONS_ACTION_COMMAND_PROPERTY,
	ACTIONS_ACTION_PATH_PROPERTY,
	ACTIONS_ACTION_STATES_PROPERTY,
	ACTIONS_ACTION_TRIGGERS_PROPERTY,
	ACTIONS_ACTION_COMMAND_VALID_PROPERTY,
	ACTIONS_ACTION_NUM_PROPERTIES
};
static GParamSpec* actions_action_properties[ACTIONS_ACTION_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define ACTIONS_TYPE_ACTION_MANAGER (actions_action_manager_get_type ())
#define ACTIONS_ACTION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ACTIONS_TYPE_ACTION_MANAGER, ActionsActionManager))
#define ACTIONS_ACTION_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ACTIONS_TYPE_ACTION_MANAGER, ActionsActionManagerClass))
#define ACTIONS_IS_ACTION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ACTIONS_TYPE_ACTION_MANAGER))
#define ACTIONS_IS_ACTION_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ACTIONS_TYPE_ACTION_MANAGER))
#define ACTIONS_ACTION_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ACTIONS_TYPE_ACTION_MANAGER, ActionsActionManagerClass))

typedef struct _ActionsActionManager ActionsActionManager;
typedef struct _ActionsActionManagerClass ActionsActionManagerClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define ACTIONS_TYPE_CONTEXT (actions_context_get_type ())
typedef struct _ActionsContext ActionsContext;
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _ActionsAction {
	GObject parent_instance;
	ActionsActionPrivate * priv;
};

struct _ActionsActionClass {
	GObjectClass parent_class;
};

typedef enum  {
	ACTIONS_STATE_NONE = 0,
	ACTIONS_STATE_POMODORO = 1,
	ACTIONS_STATE_SHORT_BREAK = 2,
	ACTIONS_STATE_LONG_BREAK = 4,
	ACTIONS_STATE_ANY = (ACTIONS_STATE_POMODORO | ACTIONS_STATE_SHORT_BREAK) | ACTIONS_STATE_LONG_BREAK
} ActionsState;

typedef enum  {
	ACTIONS_TRIGGER_NONE = 0,
	ACTIONS_TRIGGER_START = 1,
	ACTIONS_TRIGGER_COMPLETE = 2,
	ACTIONS_TRIGGER_SKIP = 4,
	ACTIONS_TRIGGER_PAUSE = 8,
	ACTIONS_TRIGGER_RESUME = 16,
	ACTIONS_TRIGGER_ENABLE = 32,
	ACTIONS_TRIGGER_DISABLE = 64
} ActionsTrigger;

struct _ActionsActionPrivate {
	gchar* _name;
	ActionsState _states;
	ActionsTrigger _triggers;
	gboolean _command_valid;
	gchar* _command;
	GSettings* settings;
	GSimpleAction* remove_action;
};

struct _ActionsContext {
	ActionsAction* action;
	ActionsTrigger triggers;
	ActionsState state;
	gdouble elapsed;
	gdouble duration;
};


static gpointer actions_action_parent_class = NULL;
static GType actions_action_type_id = 0;

GType actions_action_get_type (void) G_GNUC_CONST;
GType actions_state_get_type (void) G_GNUC_CONST;
GType actions_trigger_get_type (void) G_GNUC_CONST;
#define ACTIONS_ACTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), ACTIONS_TYPE_ACTION, ActionsActionPrivate))
ActionsAction* actions_action_new_for_path (const gchar* path);
ActionsAction* actions_action_construct_for_path (GType object_type, const gchar* path);
void actions_action_set_path (ActionsAction* self, const gchar* value);
void actions_action_reset (ActionsAction* self);
GActionGroup* actions_action_get_action_group (ActionsAction* self);
static void actions_action_activate_remove (ActionsAction* self, GSimpleAction* action, GVariant* parameter);
static void _actions_action_activate_remove_g_simple_action_activate (GSimpleAction* _sender, GVariant* parameter, gpointer self);
GType actions_action_manager_get_type (void) G_GNUC_CONST;
ActionsActionManager* actions_action_manager_get_instance (void);
void actions_action_manager_remove (ActionsActionManager* self, ActionsAction* action);
static void actions_action_validate_command (ActionsAction* self);
const gchar* actions_action_get_command (ActionsAction* self);
static void actions_action_set_command_valid (ActionsAction* self, gboolean value);
GType actions_context_get_type (void) G_GNUC_CONST;
ActionsContext* actions_context_dup (const ActionsContext* self);
void actions_context_free (ActionsContext* self);
void actions_context_copy (const ActionsContext* self, ActionsContext* dest);
void actions_context_destroy (ActionsContext* self);
gboolean actions_action_execute (ActionsAction* self, ActionsContext* context);
GList* actions_trigger_to_list (ActionsTrigger self);
gchar* actions_trigger_to_string (ActionsTrigger self);
static void _vala_array_add2 (gchar** * array, int* length, int* size, gchar* value);
gchar* actions_state_to_string (ActionsState self);
ActionsAction* actions_action_new (void);
ActionsAction* actions_action_construct (GType object_type);
const gchar* actions_action_get_name (ActionsAction* self);
void actions_action_set_name (ActionsAction* self, const gchar* value);
void actions_action_set_command (ActionsAction* self, const gchar* value);
gchar* actions_action_get_path (ActionsAction* self);
ActionsState actions_action_get_states (ActionsAction* self);
void actions_action_set_states (ActionsAction* self, ActionsState value);
ActionsTrigger actions_action_get_triggers (ActionsAction* self);
void actions_action_set_triggers (ActionsAction* self, ActionsTrigger value);
gboolean actions_action_get_command_valid (ActionsAction* self);
static void actions_action_finalize (GObject * obj);
static void _vala_actions_action_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_actions_action_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


ActionsAction* actions_action_construct_for_path (GType object_type, const gchar* path) {
	ActionsAction * self = NULL;
	const gchar* _tmp0_;
	g_return_val_if_fail (path != NULL, NULL);
	self = (ActionsAction*) g_object_new (object_type, NULL);
	_tmp0_ = path;
	actions_action_set_path (self, _tmp0_);
	return self;
}


ActionsAction* actions_action_new_for_path (const gchar* path) {
	return actions_action_construct_for_path (ACTIONS_TYPE_ACTION, path);
}


/**
         * Reset action to defaults
         */
void actions_action_reset (ActionsAction* self) {
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	g_settings_delay (_tmp0_);
	_tmp1_ = self->priv->settings;
	g_settings_reset (_tmp1_, "name");
	_tmp2_ = self->priv->settings;
	g_settings_reset (_tmp2_, "command");
	_tmp3_ = self->priv->settings;
	g_settings_reset (_tmp3_, "states");
	_tmp4_ = self->priv->settings;
	g_settings_reset (_tmp4_, "triggers");
	_tmp5_ = self->priv->settings;
	g_settings_apply (_tmp5_);
}


static void _actions_action_activate_remove_g_simple_action_activate (GSimpleAction* _sender, GVariant* parameter, gpointer self) {
	actions_action_activate_remove ((ActionsAction*) self, _sender, parameter);
}


GActionGroup* actions_action_get_action_group (ActionsAction* self) {
	GActionGroup* result = NULL;
	GSimpleActionGroup* action_group = NULL;
	GSimpleActionGroup* _tmp0_;
	GSimpleAction* _tmp1_;
	GSimpleAction* _tmp2_;
	GSimpleAction* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_simple_action_group_new ();
	action_group = _tmp0_;
	_tmp1_ = g_simple_action_new ("remove", NULL);
	_g_object_unref0 (self->priv->remove_action);
	self->priv->remove_action = _tmp1_;
	_tmp2_ = self->priv->remove_action;
	g_signal_connect_object (_tmp2_, "activate", (GCallback) _actions_action_activate_remove_g_simple_action_activate, self, 0);
	_tmp3_ = self->priv->remove_action;
	g_action_map_add_action ((GActionMap*) action_group, (GAction*) _tmp3_);
	result = (GActionGroup*) action_group;
	return result;
}


static void actions_action_activate_remove (ActionsAction* self, GSimpleAction* action, GVariant* parameter) {
	ActionsActionManager* action_manager = NULL;
	ActionsActionManager* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_tmp0_ = actions_action_manager_get_instance ();
	action_manager = _tmp0_;
	actions_action_manager_remove (action_manager, self);
	_g_object_unref0 (action_manager);
}


static void actions_action_validate_command (ActionsAction* self) {
	gchar** spawn_args = NULL;
	gint spawn_args_length1 = 0;
	gint _spawn_args_size_ = 0;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		gboolean _tmp0_ = FALSE;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar** _tmp3_ = NULL;
		gint _tmp4_;
		gboolean _tmp5_;
		_tmp1_ = actions_action_get_command (self);
		_tmp2_ = _tmp1_;
		_tmp5_ = g_shell_parse_argv (_tmp2_, &_tmp4_, &_tmp3_, &_inner_error_);
		spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
		spawn_args = _tmp3_;
		spawn_args_length1 = _tmp4_;
		_spawn_args_size_ = spawn_args_length1;
		_tmp0_ = _tmp5_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_SHELL_ERROR) {
				goto __catch2_g_shell_error;
			}
			spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		actions_action_set_command_valid (self, _tmp0_);
	}
	goto __finally2;
	__catch2_g_shell_error:
	{
		GError* _error_ = NULL;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		actions_action_set_command_valid (self, FALSE);
		_g_error_free0 (_error_);
	}
	__finally2:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
}


static void _vala_array_add2 (gchar** * array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		const gchar* _tmp2_;
		_tmp2_ = old;
		_tmp1_ = (*((gchar*) _tmp2_)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		_tmp3_ = old;
		_tmp4_ = replacement;
		_tmp0_ = g_strcmp0 (_tmp3_, _tmp4_) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp5_;
		_tmp5_ = g_strdup (self);
		result = _tmp5_;
		return result;
	}
	{
		GRegex* regex = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GRegex* _tmp9_;
		GRegex* _tmp10_;
		gchar* _tmp11_ = NULL;
		GRegex* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		_tmp6_ = old;
		_tmp7_ = g_regex_escape_string (_tmp6_, -1);
		_tmp8_ = _tmp7_;
		_tmp9_ = g_regex_new (_tmp8_, 0, 0, &_inner_error_);
		_tmp10_ = _tmp9_;
		_g_free0 (_tmp8_);
		regex = _tmp10_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch3_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp12_ = regex;
		_tmp13_ = replacement;
		_tmp14_ = g_regex_replace_literal (_tmp12_, self, (gssize) -1, 0, _tmp13_, 0, &_inner_error_);
		_tmp11_ = _tmp14_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch3_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp15_ = _tmp11_;
		_tmp11_ = NULL;
		result = _tmp15_;
		_g_free0 (_tmp11_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally3;
	__catch3_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally3:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static gchar* double_to_string (gdouble self) {
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
	_tmp2_ = g_ascii_dtostr (_tmp1_, G_ASCII_DTOSTR_BUF_SIZE, self);
	_tmp3_ = g_strdup (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp1_ = (g_free (_tmp1_), NULL);
	result = _tmp4_;
	return result;
}


static gchar* _vala_g_strjoinv (const gchar* separator, gchar** str_array, int str_array_length1) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gchar** _tmp3_;
	gint _tmp3__length1;
	_tmp0_ = separator;
	if (_tmp0_ == NULL) {
		separator = "";
	}
	_tmp3_ = str_array;
	_tmp3__length1 = str_array_length1;
	if (_tmp3_ != NULL) {
		_tmp2_ = TRUE;
	} else {
		gchar** _tmp4_;
		gint _tmp4__length1;
		_tmp4_ = str_array;
		_tmp4__length1 = str_array_length1;
		_tmp2_ = _tmp4__length1 > 0;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		gboolean _tmp5_ = FALSE;
		gchar** _tmp6_;
		gint _tmp6__length1;
		_tmp6_ = str_array;
		_tmp6__length1 = str_array_length1;
		if (_tmp6__length1 == -1) {
			gchar** _tmp7_;
			gint _tmp7__length1;
			const gchar* _tmp8_;
			_tmp7_ = str_array;
			_tmp7__length1 = str_array_length1;
			_tmp8_ = _tmp7_[0];
			_tmp5_ = _tmp8_ != NULL;
		} else {
			_tmp5_ = FALSE;
		}
		_tmp1_ = _tmp5_;
	}
	if (_tmp1_) {
		gint i = 0;
		gsize len = 0UL;
		gint _tmp31_;
		gint _tmp33_;
		gint _tmp34_;
		gsize _tmp35_;
		const gchar* _tmp36_;
		gint _tmp37_;
		gint _tmp38_;
		gint _tmp39_;
		const gchar* res = NULL;
		gsize _tmp40_;
		void* _tmp41_;
		void* ptr = NULL;
		const gchar* _tmp42_;
		gchar** _tmp43_;
		gint _tmp43__length1;
		const gchar* _tmp44_;
		void* _tmp45_;
		const gchar* _tmp62_;
		len = (gsize) 1;
		{
			gboolean _tmp9_ = FALSE;
			i = 0;
			_tmp9_ = TRUE;
			while (TRUE) {
				gboolean _tmp11_ = FALSE;
				gboolean _tmp12_ = FALSE;
				gchar** _tmp13_;
				gint _tmp13__length1;
				gint _tmp21_ = 0;
				gchar** _tmp22_;
				gint _tmp22__length1;
				gint _tmp23_;
				const gchar* _tmp24_;
				gsize _tmp30_;
				if (!_tmp9_) {
					gint _tmp10_;
					_tmp10_ = i;
					i = _tmp10_ + 1;
				}
				_tmp9_ = FALSE;
				_tmp13_ = str_array;
				_tmp13__length1 = str_array_length1;
				if (_tmp13__length1 != -1) {
					gint _tmp14_;
					gchar** _tmp15_;
					gint _tmp15__length1;
					_tmp14_ = i;
					_tmp15_ = str_array;
					_tmp15__length1 = str_array_length1;
					_tmp12_ = _tmp14_ < _tmp15__length1;
				} else {
					_tmp12_ = FALSE;
				}
				if (_tmp12_) {
					_tmp11_ = TRUE;
				} else {
					gboolean _tmp16_ = FALSE;
					gchar** _tmp17_;
					gint _tmp17__length1;
					_tmp17_ = str_array;
					_tmp17__length1 = str_array_length1;
					if (_tmp17__length1 == -1) {
						gchar** _tmp18_;
						gint _tmp18__length1;
						gint _tmp19_;
						const gchar* _tmp20_;
						_tmp18_ = str_array;
						_tmp18__length1 = str_array_length1;
						_tmp19_ = i;
						_tmp20_ = _tmp18_[_tmp19_];
						_tmp16_ = _tmp20_ != NULL;
					} else {
						_tmp16_ = FALSE;
					}
					_tmp11_ = _tmp16_;
				}
				if (!_tmp11_) {
					break;
				}
				_tmp22_ = str_array;
				_tmp22__length1 = str_array_length1;
				_tmp23_ = i;
				_tmp24_ = _tmp22_[_tmp23_];
				if (_tmp24_ != NULL) {
					gchar** _tmp25_;
					gint _tmp25__length1;
					gint _tmp26_;
					const gchar* _tmp27_;
					gint _tmp28_;
					gint _tmp29_;
					_tmp25_ = str_array;
					_tmp25__length1 = str_array_length1;
					_tmp26_ = i;
					_tmp27_ = _tmp25_[_tmp26_];
					_tmp28_ = strlen ((const gchar*) _tmp27_);
					_tmp29_ = _tmp28_;
					_tmp21_ = _tmp29_;
				} else {
					_tmp21_ = 0;
				}
				_tmp30_ = len;
				len = _tmp30_ + _tmp21_;
			}
		}
		_tmp31_ = i;
		if (_tmp31_ == 0) {
			gchar* _tmp32_;
			_tmp32_ = g_strdup ("");
			result = _tmp32_;
			return result;
		}
		_tmp33_ = i;
		str_array_length1 = _tmp33_;
		_tmp34_ = str_array_length1;
		_tmp35_ = len;
		_tmp36_ = separator;
		_tmp37_ = strlen ((const gchar*) _tmp36_);
		_tmp38_ = _tmp37_;
		_tmp39_ = i;
		len = _tmp35_ + (_tmp38_ * (_tmp39_ - 1));
		_tmp40_ = len;
		_tmp41_ = g_malloc (_tmp40_);
		res = _tmp41_;
		_tmp42_ = res;
		_tmp43_ = str_array;
		_tmp43__length1 = str_array_length1;
		_tmp44_ = _tmp43_[0];
		_tmp45_ = g_stpcpy ((void*) _tmp42_, (const gchar*) _tmp44_);
		ptr = _tmp45_;
		{
			gboolean _tmp46_ = FALSE;
			i = 1;
			_tmp46_ = TRUE;
			while (TRUE) {
				gint _tmp48_;
				gchar** _tmp49_;
				gint _tmp49__length1;
				void* _tmp50_;
				const gchar* _tmp51_;
				void* _tmp52_;
				const gchar* _tmp53_ = NULL;
				gchar** _tmp54_;
				gint _tmp54__length1;
				gint _tmp55_;
				const gchar* _tmp56_;
				void* _tmp60_;
				void* _tmp61_;
				if (!_tmp46_) {
					gint _tmp47_;
					_tmp47_ = i;
					i = _tmp47_ + 1;
				}
				_tmp46_ = FALSE;
				_tmp48_ = i;
				_tmp49_ = str_array;
				_tmp49__length1 = str_array_length1;
				if (!(_tmp48_ < _tmp49__length1)) {
					break;
				}
				_tmp50_ = ptr;
				_tmp51_ = separator;
				_tmp52_ = g_stpcpy (_tmp50_, (const gchar*) _tmp51_);
				ptr = _tmp52_;
				_tmp54_ = str_array;
				_tmp54__length1 = str_array_length1;
				_tmp55_ = i;
				_tmp56_ = _tmp54_[_tmp55_];
				if (_tmp56_ != NULL) {
					gchar** _tmp57_;
					gint _tmp57__length1;
					gint _tmp58_;
					const gchar* _tmp59_;
					_tmp57_ = str_array;
					_tmp57__length1 = str_array_length1;
					_tmp58_ = i;
					_tmp59_ = _tmp57_[_tmp58_];
					_tmp53_ = (const gchar*) _tmp59_;
				} else {
					_tmp53_ = "";
				}
				_tmp60_ = ptr;
				_tmp61_ = g_stpcpy (_tmp60_, _tmp53_);
				ptr = _tmp61_;
			}
		}
		_tmp62_ = res;
		res = NULL;
		result = (gchar*) _tmp62_;
		return result;
	} else {
		gchar* _tmp63_;
		_tmp63_ = g_strdup ("");
		result = _tmp63_;
		return result;
	}
}


gboolean actions_action_execute (ActionsAction* self, ActionsContext* context) {
	gboolean result = FALSE;
	gchar** spawn_env = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint spawn_env_length1;
	gint _spawn_env_size_;
	gchar** spawn_args = NULL;
	gint spawn_args_length1 = 0;
	gint _spawn_args_size_ = 0;
	gchar** trigger_strings = NULL;
	gchar** _tmp2_;
	gint trigger_strings_length1;
	gint _trigger_strings_size_;
	ActionsContext _tmp3_;
	ActionsTrigger _tmp4_;
	GList* _tmp5_;
	gchar* command = NULL;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	ActionsContext _tmp13_;
	ActionsState _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	ActionsContext _tmp19_;
	gdouble _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	const gchar* _tmp24_;
	ActionsContext _tmp25_;
	gdouble _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	const gchar* _tmp30_;
	gchar** _tmp31_;
	gint _tmp31__length1;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (context != NULL, FALSE);
	_tmp1_ = _tmp0_ = g_get_environ ();
	spawn_env = _tmp1_;
	spawn_env_length1 = _vala_array_length (_tmp0_);
	_spawn_env_size_ = spawn_env_length1;
	_tmp2_ = g_new0 (gchar*, 0 + 1);
	trigger_strings = _tmp2_;
	trigger_strings_length1 = 0;
	_trigger_strings_size_ = trigger_strings_length1;
	_tmp3_ = *context;
	_tmp4_ = _tmp3_.triggers;
	_tmp5_ = actions_trigger_to_list (_tmp4_);
	{
		GList* trigger_collection = NULL;
		GList* trigger_it = NULL;
		trigger_collection = _tmp5_;
		for (trigger_it = trigger_collection; trigger_it != NULL; trigger_it = trigger_it->next) {
			ActionsTrigger trigger = 0;
			trigger = (ActionsTrigger) ((gintptr) trigger_it->data);
			{
				gchar** _tmp6_;
				gint _tmp6__length1;
				ActionsTrigger _tmp7_;
				gchar* _tmp8_;
				_tmp6_ = trigger_strings;
				_tmp6__length1 = trigger_strings_length1;
				_tmp7_ = trigger;
				_tmp8_ = actions_trigger_to_string (_tmp7_);
				_vala_array_add2 (&trigger_strings, &trigger_strings_length1, &_trigger_strings_size_, _tmp8_);
			}
		}
		_g_list_free0 (trigger_collection);
	}
	_tmp9_ = actions_action_get_command (self);
	_tmp10_ = _tmp9_;
	_tmp11_ = g_strdup (_tmp10_);
	command = _tmp11_;
	_tmp12_ = command;
	_tmp13_ = *context;
	_tmp14_ = _tmp13_.state;
	_tmp15_ = actions_state_to_string (_tmp14_);
	_tmp16_ = _tmp15_;
	_tmp17_ = string_replace (_tmp12_, "$(state)", _tmp16_);
	_g_free0 (command);
	command = _tmp17_;
	_g_free0 (_tmp16_);
	_tmp18_ = command;
	_tmp19_ = *context;
	_tmp20_ = _tmp19_.elapsed;
	_tmp21_ = double_to_string (_tmp20_);
	_tmp22_ = _tmp21_;
	_tmp23_ = string_replace (_tmp18_, "$(elapsed)", _tmp22_);
	_g_free0 (command);
	command = _tmp23_;
	_g_free0 (_tmp22_);
	_tmp24_ = command;
	_tmp25_ = *context;
	_tmp26_ = _tmp25_.duration;
	_tmp27_ = double_to_string (_tmp26_);
	_tmp28_ = _tmp27_;
	_tmp29_ = string_replace (_tmp24_, "$(duration)", _tmp28_);
	_g_free0 (command);
	command = _tmp29_;
	_g_free0 (_tmp28_);
	_tmp30_ = command;
	_tmp31_ = trigger_strings;
	_tmp31__length1 = trigger_strings_length1;
	_tmp32_ = _vala_g_strjoinv (" ", _tmp31_, _tmp31__length1);
	_tmp33_ = _tmp32_;
	_tmp34_ = string_replace (_tmp30_, "$(triggers)", _tmp33_);
	_g_free0 (command);
	command = _tmp34_;
	_g_free0 (_tmp33_);
	{
		const gchar* _tmp35_;
		gchar** _tmp36_ = NULL;
		gint _tmp37_;
		_tmp35_ = command;
		g_shell_parse_argv (_tmp35_, &_tmp37_, &_tmp36_, &_inner_error_);
		spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
		spawn_args = _tmp36_;
		spawn_args_length1 = _tmp37_;
		_spawn_args_size_ = spawn_args_length1;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			gboolean _tmp38_ = FALSE;
			if (_inner_error_->domain == G_SHELL_ERROR) {
				goto __catch4_g_shell_error;
			}
			_g_free0 (command);
			trigger_strings = (_vala_array_free (trigger_strings, trigger_strings_length1, (GDestroyNotify) g_free), NULL);
			spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
			spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return _tmp38_;
		}
	}
	goto __finally4;
	__catch4_g_shell_error:
	{
		GError* _error_ = NULL;
		const gchar* _tmp39_;
		GError* _tmp40_;
		const gchar* _tmp41_;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		_tmp39_ = command;
		_tmp40_ = _error_;
		_tmp41_ = _tmp40_->message;
		g_debug ("action.vala:151: Error while executing command \"%s\": %s", _tmp39_, _tmp41_);
		result = FALSE;
		_g_error_free0 (_error_);
		_g_free0 (command);
		trigger_strings = (_vala_array_free (trigger_strings, trigger_strings_length1, (GDestroyNotify) g_free), NULL);
		spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
		spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	__finally4:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gboolean _tmp42_ = FALSE;
		_g_free0 (command);
		trigger_strings = (_vala_array_free (trigger_strings, trigger_strings_length1, (GDestroyNotify) g_free), NULL);
		spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
		spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp42_;
	}
	{
		gchar** _tmp43_;
		gint _tmp43__length1;
		gchar** _tmp44_;
		gint _tmp44__length1;
		_tmp43_ = spawn_args;
		_tmp43__length1 = spawn_args_length1;
		_tmp44_ = spawn_env;
		_tmp44__length1 = spawn_env_length1;
		g_spawn_sync ("/", _tmp43_, _tmp44_, G_SPAWN_SEARCH_PATH, NULL, NULL, NULL, NULL, NULL, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			gboolean _tmp45_ = FALSE;
			if (_inner_error_->domain == G_SPAWN_ERROR) {
				goto __catch5_g_spawn_error;
			}
			_g_free0 (command);
			trigger_strings = (_vala_array_free (trigger_strings, trigger_strings_length1, (GDestroyNotify) g_free), NULL);
			spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
			spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return _tmp45_;
		}
	}
	goto __finally5;
	__catch5_g_spawn_error:
	{
		GError* _error_ = NULL;
		FILE* _tmp46_;
		GError* _tmp47_;
		const gchar* _tmp48_;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		_tmp46_ = stdout;
		_tmp47_ = _error_;
		_tmp48_ = _tmp47_->message;
		fprintf (_tmp46_, "Error: %s\n", _tmp48_);
		result = FALSE;
		_g_error_free0 (_error_);
		_g_free0 (command);
		trigger_strings = (_vala_array_free (trigger_strings, trigger_strings_length1, (GDestroyNotify) g_free), NULL);
		spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
		spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	__finally5:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gboolean _tmp49_ = FALSE;
		_g_free0 (command);
		trigger_strings = (_vala_array_free (trigger_strings, trigger_strings_length1, (GDestroyNotify) g_free), NULL);
		spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
		spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp49_;
	}
	result = TRUE;
	_g_free0 (command);
	trigger_strings = (_vala_array_free (trigger_strings, trigger_strings_length1, (GDestroyNotify) g_free), NULL);
	spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
	spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
	return result;
}


ActionsAction* actions_action_construct (GType object_type) {
	ActionsAction * self = NULL;
	self = (ActionsAction*) g_object_new (object_type, NULL);
	return self;
}


ActionsAction* actions_action_new (void) {
	return actions_action_construct (ACTIONS_TYPE_ACTION);
}


const gchar* actions_action_get_name (ActionsAction* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}


void actions_action_set_name (ActionsAction* self, const gchar* value) {
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, actions_action_get_name (self)) != 0) {
		const gchar* _tmp0_;
		gchar* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = g_strdup (_tmp0_);
		_g_free0 (self->priv->_name);
		self->priv->_name = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, actions_action_properties[ACTIONS_ACTION_NAME_PROPERTY]);
	}
}


const gchar* actions_action_get_command (ActionsAction* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_command;
	result = _tmp0_;
	return result;
}


void actions_action_set_command (ActionsAction* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_command);
	self->priv->_command = _tmp1_;
	actions_action_validate_command (self);
	g_object_notify_by_pspec ((GObject *) self, actions_action_properties[ACTIONS_ACTION_COMMAND_PROPERTY]);
}


gchar* actions_action_get_path (ActionsAction* self) {
	gchar* result;
	gchar* _tmp0_ = NULL;
	GSettings* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = self->priv->settings;
	if (_tmp1_ != NULL) {
		GSettings* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		_tmp2_ = self->priv->settings;
		g_object_get (_tmp2_, "path", &_tmp3_, NULL);
		_tmp4_ = _tmp3_;
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp4_;
	} else {
		_g_free0 (_tmp0_);
		_tmp0_ = NULL;
	}
	result = _tmp0_;
	return result;
}


void actions_action_set_path (ActionsAction* self, const gchar* value) {
	const gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	if (_tmp0_ != NULL) {
		const gchar* _tmp1_;
		GSettings* _tmp2_;
		GSettings* _tmp3_;
		GSettings* _tmp4_;
		GSettings* _tmp5_;
		GSettings* _tmp6_;
		_tmp1_ = value;
		_tmp2_ = g_settings_new_with_path ("org.gnome.pomodoro.plugins.actions.action", _tmp1_);
		_g_object_unref0 (self->priv->settings);
		self->priv->settings = _tmp2_;
		_tmp3_ = self->priv->settings;
		g_settings_bind (_tmp3_, "name", (GObject*) self, "name", G_SETTINGS_BIND_DEFAULT);
		_tmp4_ = self->priv->settings;
		g_settings_bind (_tmp4_, "command", (GObject*) self, "command", G_SETTINGS_BIND_DEFAULT);
		_tmp5_ = self->priv->settings;
		g_settings_bind (_tmp5_, "states", (GObject*) self, "states", G_SETTINGS_BIND_DEFAULT);
		_tmp6_ = self->priv->settings;
		g_settings_bind (_tmp6_, "triggers", (GObject*) self, "triggers", G_SETTINGS_BIND_DEFAULT);
	} else {
		_g_object_unref0 (self->priv->settings);
		self->priv->settings = NULL;
	}
	g_object_notify_by_pspec ((GObject *) self, actions_action_properties[ACTIONS_ACTION_PATH_PROPERTY]);
}


ActionsState actions_action_get_states (ActionsAction* self) {
	ActionsState result;
	ActionsState _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_states;
	result = _tmp0_;
	return result;
}


void actions_action_set_states (ActionsAction* self, ActionsState value) {
	g_return_if_fail (self != NULL);
	if (actions_action_get_states (self) != value) {
		ActionsState _tmp0_;
		_tmp0_ = value;
		self->priv->_states = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, actions_action_properties[ACTIONS_ACTION_STATES_PROPERTY]);
	}
}


ActionsTrigger actions_action_get_triggers (ActionsAction* self) {
	ActionsTrigger result;
	ActionsTrigger _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_triggers;
	result = _tmp0_;
	return result;
}


void actions_action_set_triggers (ActionsAction* self, ActionsTrigger value) {
	g_return_if_fail (self != NULL);
	if (actions_action_get_triggers (self) != value) {
		ActionsTrigger _tmp0_;
		_tmp0_ = value;
		self->priv->_triggers = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, actions_action_properties[ACTIONS_ACTION_TRIGGERS_PROPERTY]);
	}
}


gboolean actions_action_get_command_valid (ActionsAction* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_command_valid;
	result = _tmp0_;
	return result;
}


static void actions_action_set_command_valid (ActionsAction* self, gboolean value) {
	g_return_if_fail (self != NULL);
	if (actions_action_get_command_valid (self) != value) {
		gboolean _tmp0_;
		_tmp0_ = value;
		self->priv->_command_valid = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, actions_action_properties[ACTIONS_ACTION_COMMAND_VALID_PROPERTY]);
	}
}


static void actions_action_class_init (ActionsActionClass * klass) {
	actions_action_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ActionsActionPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_actions_action_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_actions_action_set_property;
	G_OBJECT_CLASS (klass)->finalize = actions_action_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACTIONS_ACTION_NAME_PROPERTY, actions_action_properties[ACTIONS_ACTION_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACTIONS_ACTION_COMMAND_PROPERTY, actions_action_properties[ACTIONS_ACTION_COMMAND_PROPERTY] = g_param_spec_string ("command", "command", "command", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACTIONS_ACTION_PATH_PROPERTY, actions_action_properties[ACTIONS_ACTION_PATH_PROPERTY] = g_param_spec_string ("path", "path", "path", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACTIONS_ACTION_STATES_PROPERTY, actions_action_properties[ACTIONS_ACTION_STATES_PROPERTY] = g_param_spec_flags ("states", "states", "states", ACTIONS_TYPE_STATE, ACTIONS_STATE_ANY, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACTIONS_ACTION_TRIGGERS_PROPERTY, actions_action_properties[ACTIONS_ACTION_TRIGGERS_PROPERTY] = g_param_spec_flags ("triggers", "triggers", "triggers", ACTIONS_TYPE_TRIGGER, ACTIONS_TRIGGER_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACTIONS_ACTION_COMMAND_VALID_PROPERTY, actions_action_properties[ACTIONS_ACTION_COMMAND_VALID_PROPERTY] = g_param_spec_boolean ("command-valid", "command-valid", "command-valid", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void actions_action_instance_init (ActionsAction * self) {
	self->priv = ACTIONS_ACTION_GET_PRIVATE (self);
	self->priv->_states = ACTIONS_STATE_ANY;
	self->priv->_triggers = ACTIONS_TRIGGER_NONE;
	self->priv->_command_valid = FALSE;
}


static void actions_action_finalize (GObject * obj) {
	ActionsAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ACTIONS_TYPE_ACTION, ActionsAction);
	_g_free0 (self->priv->_name);
	_g_free0 (self->priv->_command);
	_g_object_unref0 (self->priv->settings);
	_g_object_unref0 (self->priv->remove_action);
	G_OBJECT_CLASS (actions_action_parent_class)->finalize (obj);
}


GType actions_action_get_type (void) {
	return actions_action_type_id;
}


GType actions_action_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (ActionsActionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) actions_action_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ActionsAction), 0, (GInstanceInitFunc) actions_action_instance_init, NULL };
	actions_action_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "ActionsAction", &g_define_type_info, 0);
	return actions_action_type_id;
}


static void _vala_actions_action_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ActionsAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, ACTIONS_TYPE_ACTION, ActionsAction);
	switch (property_id) {
		case ACTIONS_ACTION_NAME_PROPERTY:
		g_value_set_string (value, actions_action_get_name (self));
		break;
		case ACTIONS_ACTION_COMMAND_PROPERTY:
		g_value_set_string (value, actions_action_get_command (self));
		break;
		case ACTIONS_ACTION_PATH_PROPERTY:
		g_value_take_string (value, actions_action_get_path (self));
		break;
		case ACTIONS_ACTION_STATES_PROPERTY:
		g_value_set_flags (value, actions_action_get_states (self));
		break;
		case ACTIONS_ACTION_TRIGGERS_PROPERTY:
		g_value_set_flags (value, actions_action_get_triggers (self));
		break;
		case ACTIONS_ACTION_COMMAND_VALID_PROPERTY:
		g_value_set_boolean (value, actions_action_get_command_valid (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_actions_action_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ActionsAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, ACTIONS_TYPE_ACTION, ActionsAction);
	switch (property_id) {
		case ACTIONS_ACTION_NAME_PROPERTY:
		actions_action_set_name (self, g_value_get_string (value));
		break;
		case ACTIONS_ACTION_COMMAND_PROPERTY:
		actions_action_set_command (self, g_value_get_string (value));
		break;
		case ACTIONS_ACTION_PATH_PROPERTY:
		actions_action_set_path (self, g_value_get_string (value));
		break;
		case ACTIONS_ACTION_STATES_PROPERTY:
		actions_action_set_states (self, g_value_get_flags (value));
		break;
		case ACTIONS_ACTION_TRIGGERS_PROPERTY:
		actions_action_set_triggers (self, g_value_get_flags (value));
		break;
		case ACTIONS_ACTION_COMMAND_VALID_PROPERTY:
		actions_action_set_command_valid (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



